/* util.h
 *
 * Copyright (C) 2007-2008 Tillmann Werner <tillmann.werner@gmx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as
 * published by the Free Software Foundation.  You may not use, modify or
 * distribute this program under any other version of the GNU General
 * Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __NEBULA_CLIENT_UTIL_H
#define __NEBULA_CLIENT_UTIL_H 1

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <dirent.h>
#include <sys/types.h>

typedef struct bstring {
	u_int32_t len;
	u_char *data;
} bstring;

bstring bstr_map(const char* filename);
void bstr_unmap(bstring bstr);

#if defined(OS_BSD) || defined (OS_DARWIN)
int regular_file(struct dirent *e);
#else
int regular_file(const struct dirent *e);
#endif 

int timesort(const void *a, const void *b);

#endif
