/* hash.c
 *
 * Copyright (C) 2007 Tillmann Werner <tillmann.werner@gmx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as
 * published by the Free Software Foundation.  You may not use, modify or
 * distribute this program under any other version of the GNU General
 * Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "hash.h"
#include "nebula.h"
#include "session.h"

hash *hash_new(void) {
	hash *new;
	if ((new = calloc(1, sizeof(hash))) == NULL) {
		fprintf(stderr, "Error - Unable to allocate memory: %s.\n", strerror(errno));
		exit(EXIT_FAILURE);
	}
	return(new);
}


void hash_free(void *h) {
	if (!h) return;

	free(((hash *)h)->md5sum);
	((hash *)h)->md5sum = NULL;

	if (((hash *)h)->submission)
		((submission *)((hash *)h)->submission)->md5sum = NULL;

	free(((hash *)h)->spamsum);
	((hash *)h)->spamsum = NULL;

	free(((hash *)h)->sha512sum);
	((hash *)h)->sha512sum = NULL;

	session_reset(((hash *)h)->submission, -1);
	free(((hash *)h)->submission);
	((hash *)h)->submission = NULL;

	if (((hash *)h)->free) ((hash *)h)->free(h);
	free(h);
	return;
}
