/* hash.h
 *
 * Copyright (C) 2007 Tillmann Werner <tillmann.werner@gmx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as
 * published by the Free Software Foundation.  You may not use, modify or
 * distribute this program under any other version of the GNU General
 * Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __NEBULA_HASH_H
#define __NEBULA_HASH_H 1

#if HAVE_CONFIG_H
# include <config.h>
#endif


struct cluster;

typedef struct hash {
	u_int16_t	cnt;
	u_int16_t	hashlen;
	u_int16_t	filecnt;
	char		*md5sum;
	char		*spamsum;
	char		*sha512sum;
	void		*submission;
	struct cluster	*cl;
	void		(*free)(struct hash *h);
} hash;


hash *hash_new(void);
void hash_free(void *cl);

#endif
