/* lca.h
 *
 * Copyright (C) 2007-2008 Tillmann Werner <tillmann.werner@gmx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as
 * published by the Free Software Foundation.  You may not use, modify or
 * distribute this program under any other version of the GNU General
 * Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __NEBULA_LCA_H
#define __NEBULA_LCA_H 1

#include <sys/types.h>

#include "stree.h"


// lca struct
typedef struct {
	stree		*tree;
	u_int32_t	*I, *A;
	stnode		*L;
	int		num_prep, num_compares;
} lcatbl;


lcatbl *lca_prep(stree *tree);
stnode *lca_lookup(lcatbl *lca, stnode *x, stnode *y);
void lca_free(lcatbl *lca);

ssize_t calc_common_subtree(stree *t, substr_list *cstr_list, ssize_t min_length, lcatbl *lca_table, stnode **leaves, ssize_t num_leaves, ssize_t num_of_files);

#endif
