/* nebula.h
 *
 * Copyright (C) 2007-2008 Tillmann Werner <tillmann.werner@gmx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as
 * published by the Free Software Foundation.  You may not use, modify or
 * distribute this program under any other version of the GNU General
 * Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __NEBULA_H
#define __NEBULA_H 1


#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <pthread.h>
//#include <semaphore.h>

#include "avl.h"
#include "cluster.h"
#include "hash.h"
#include "sem.h"
#include "session.h"
#include "stree.h"


#define POLLFD_MAX_SET_SIZE	255
#define LISTEN_SOCK		pfdset[0]

submission		s[POLLFD_MAX_SET_SIZE+1];
struct pollfd		pfdset[POLLFD_MAX_SET_SIZE+1];
nfds_t			pollfd_set_size;		// size of dynamically adjusted set

int			lock_mutex;

u_char			verbose;
char			*secret;
trie_node		spamsum_trie, md5sum_trie, sighash_trie;

ssize_t			clusterq_max, clusterhashq_max, outlierq_max; 
double			sim_threshold;

unsigned long		initial_threshold;

ssize_t			min_sstr_len;
double			min_sstr_ent;

queue			*clusterq;
queue			*outlierq;

queue			*classifyq;	// clustering job queue
queue			*siggenq;	// signature generation job queue


pthread_mutex_t		classifyq_mutex;
pthread_mutex_t		siggenq_mutex;

pthread_rwlock_t	md5sum_trie_lock;
pthread_rwlock_t	spamsum_trie_lock;
pthread_rwlock_t	sighash_trie_lock;

repsem_t			sessions_semaphore;
repsem_t			siggen_semaphore;

#endif
