/* trie.h
 *
 * Copyright (C) 2007 Tillmann Werner <tillmann.werner@gmx.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 as
 * published by the Free Software Foundation.  You may not use, modify or
 * distribute this program under any other version of the GNU General
 * Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __NEBULA_TRIE_H
#define __NEBULA_TRIE_H 1

#if HAVE_CONFIG_H
# include <config.h>
#endif

struct trie_node;
typedef struct trie_node *trie;

typedef struct trie_node {
	u_char key;
	u_int16_t childlist_len;
	trie childlist;
	void *data;
} trie_node;


void print_trie(const trie t, int depth);

trie trie_find_node(const trie t, const u_int16_t size, const u_char key);
trie trie_find_memstr(trie t, const u_char* data, u_int16_t n);
int trie_del_memstr(trie t, const u_char* data, u_int16_t n);
trie trie_insert_node(trie parent, const u_char key);
trie trie_memins(trie t, const u_char *data, ssize_t n, void(*cbfn)(trie t));
void trie_delete(trie t, u_int16_t node_size, void(*cbfn)(trie t));

#endif
